# This railtie provides Rails engine hooks

module HonestPubsub
  class Railtie < ::Rails::Railtie
    initializer "honest_pubsub.insert_middleware" do |app|
      app.config.middleware.use HonestPubsub::Middleware
    end

    console do
      # Set up basic context to identify messages getting generated from console
      HonestPubsub::Context.setup_context(
        application: "#{HonestPubsub::Configuration.application_name}/console",
        hostname: `hostname`.strip,
        unique_id: Digest::SHA1.new.to_s
      )
    end

    rake_tasks do
      # Set up basic context to identify messages getting generated from rake tasks
      HonestPubsub::Context.setup_context(
        application: "#{HonestPubsub::Configuration.application_name}/rake",
        hostname: `hostname`.strip,
        unique_id: Digest::SHA1.new.to_s
      )
    end
  end
end
